package com.tzld.piaoquan.ad.engine.service.predict.model.threshold;

import com.tzld.piaoquan.ad.engine.service.predict.container.RandWContainer;
import com.tzld.piaoquan.ad.engine.service.predict.param.ThresholdPredictModelParam;
import com.tzld.piaoquan.ad.engine.service.remote.FeatureRemoteService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

@Component
public class RandomPredictModel extends ThresholdPredictModel {
    private final static Logger log = LoggerFactory.getLogger(RandomPredictModel.class);

    @Override
    String initName() {
        return "random";
    }


    @Override
    public Map<String, Object> predict(ThresholdPredictModelParam modelParam) {
        int hash=modelParam.getMid().hashCode();
        hash=hash<0?-hash:hash;
        double score=(hash+ RandWContainer.getRandW())%100/100d;
        double threshold=Double.parseDouble(
                modelParam.getExtraParam().getOrDefault(modelParam.getAppType()+"_"+modelParam.getUserExtraFuture("shareType").toString(),-1
                ).toString());
        if(threshold<0d){
            threshold=Double.parseDouble(
                    modelParam.getExtraParam().getOrDefault("default_threshold","0.5")
                    .toString());
        }
        Map<String, Object> result = new HashMap<>();
        result.put("ad_predict", score<threshold?2:1);
        result.put("score", score);
        result.put("threshold", threshold);

        return result;
    }

}
